# how long the computer must be idle for before shutting down the monitor in seconds
$idletimeout=120
#$idletimeout=20

# how long the ecu must be disconnected for before shutting down the computer in seconds
$ecushutdown=13920
#$ecushutdown=60


# how long the ECU must be disconnected for before shutting down the monitor in seconds
$ecutimeout=15

# How long the ECU must be disconnected before restarting TS, if it's running, to allow logs to be uploaded.
$tstimeout=900

# how frequently to check the ecu and idle states in seconds
$frequency=3

#ECU USB Device ID
$ecuid="USB\\VID_3356&PID_3003"

#log file
$logfile="d:\logs\check-ecu-connected.log"

#ECU State file
$ecustatefile="d:\logs\ecustate.log"

#TunerStudio process name (usually javaw)
$tsprocessname="javaw"

#TunerStudio Window Title (usually contains tunerstudio; include "*" before and after the search string)
$tswindowtitle="tunerstudio"

# Path to TunerStudio startup script
$tsscript="C:\Program Files (x86)\EFIAnalytics\TunerStudioMS3Pro\TunerStudio.cmd"



#$rdpsession=query session /counter|where {$_ -like "*rdp*active*"}
#if ($rdpsession -ne $null) {write "Active Session"}


function closets {
				$date=get-date
				write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTS"
				write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTS" | out-file $logfile -append

				if ((get-process -erroraction silentlycontinue -name $tsprocessname | where {$_.mainwindowtitle -like "*$tswindowtitle*"})) {
					write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSgraceful"
					write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSgraceful" | out-file $logfile -append
					(get-process -erroraction silentlycontinue -name $tsprocessname | where {$_.mainwindowtitle -like "*$tswindowtitle*"}).CloseMainWindow()
					sleep 10
					$date=get-date
					if ((get-process -erroraction silentlycontinue -name $tsprocessname | where {$_.mainwindowtitle -like "*$tswindowtitle*"})) {
						write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSsave"
						write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSsave" | out-file $logfile -append
						$tswindowtitlem=(get-process -erroraction silentlycontinue -name $tsprocessname | where {$_.mainwindowtitle -like "*$tswindowtitle*"}).MainWindowTitle
						$wshell = new-object -com wscript.shell
						$wshell.AppActivate("$tswindowtitlem")
						$wshell.Sendkeys("{ENTER}")
						sleep 10
						$date=get-date
						if ((get-process -erroraction silentlycontinue -name $tsprocessname | where {$_.mainwindowtitle -like "*$tswindowtitle*"})) {
							write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSforce"
							write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSforce" | out-file $logfile -append
							get-process -erroraction silentlycontinue -name $tsprocessname | where {$_.mainwindowtitle -like "*$tswindowtitle*"}|stop-process -force
						} else {
							write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSsaveSuccess"
							write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSsaveSuccess" | out-file $logfile -append
						}
					} else {
						write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSgracefulSuccess"
						write "$date,Disconnected,$disctime,0,$timesince,$idle,CloseTSgracefulSuccess" | out-file $logfile -append
					}
				} else {
					write "$date,Disconnected,$disctime,0,$timesince,$idle,TSnotRunning"
					write "$date,Disconnected,$disctime,0,$timesince,$idle,TSnotRunning" | out-file $logfile -append
				}
				get-process -erroraction silentlycontinue -name $tsprocessname | stop-process -force
}


Add-Type @'
using System;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace PInvoke.Win32 {

    public static class UserInput {

        [DllImport("user32.dll", SetLastError=false)]
        private static extern bool GetLastInputInfo(ref LASTINPUTINFO plii);

        [StructLayout(LayoutKind.Sequential)]
        private struct LASTINPUTINFO {
            public uint cbSize;
            public int dwTime;
        }

        public static DateTime LastInput {
            get {
                DateTime bootTime = DateTime.UtcNow.AddMilliseconds(-Environment.TickCount);
                DateTime lastInput = bootTime.AddMilliseconds(LastInputTicks);
                return lastInput;
            }
        }

        public static TimeSpan IdleTime {
            get {
                return DateTime.UtcNow.Subtract(LastInput);
            }
        }

        public static int LastInputTicks {
            get {
                LASTINPUTINFO lii = new LASTINPUTINFO();
                lii.cbSize = (uint)Marshal.SizeOf(typeof(LASTINPUTINFO));
                GetLastInputInfo(ref lii);
                return lii.dwTime;
            }
        }
    }
}
'@


$HWND = -1
$WM_SYSCOMMAND = 0x0112
$SC_MONITORPOWER = 0xF170
$MONITOR_OFF = 2

$signature = @"
[DllImport("user32.dll")]
public static extern int SendMessage(int hWnd, int hMsg, int wParam, int lParam);
"@

$SendMessage = Add-Type -MemberDefinition $signature -Name "Win32SendMessage" -Namespace Win32Functions -PassThru

write "Current Date/Time, Connection State of ECU, Date/Time Connected/Disconnected, Length of time connected, Length of time disconnected, Length of time user idle, target system state"
$firstrun=$true
while ($true) {

#	$ECUConnected= TS is running and state file exists and "
	if ((test-path $ecustatefile) -and (get-process -erroraction silentlycontinue -name $tsprocessname | where {$_.mainwindowtitle -like "*$tswindowtitle*"})) {
		$ecustate=get-content $ecustatefile
		if ($ecustate -ne "online") {$ecustate="offline"}
	} else {
		$ecustate="offline"
	}
#	$ms3pro=Get-PnpDevice -presentonly|where {$_.instanceid -match $ecuid}|select friendlyname,instanceid
	$date=get-date
	$idle=[math]::round(([timespan]([PInvoke.Win32.UserInput]::IdleTime)).TotalSeconds,1)
	if ($ecustate -eq "online") {
		if ($contime -eq $null) {
			$contime=$date
			write "$date,Connected,$contime,$conlength,0,$idle,Online"
			write "$date,Connected,$contime,$conlength,0,$idle,Online" | out-file $logfile -append
		}
		$conlength=[math]::Round(([timespan]($date - $contime)).TotalSeconds,1)
		if ($compstate -eq "monitoroff") {
			write "$date,Connected,$contime,$conlength,0,$idle,StayAwake"
			write "$date,Connected,$contime,$conlength,0,$idle,StayAwake" | out-file $logfile -append
			$WShell = New-Object -Com "Wscript.Shell"
			$WShell.SendKeys('+')
		}
		$compstate="stayawake"
		if ($disctime -ne $null) {remove-variable -name disctime}
	} else {
		if ($disctime -eq $null) {
			$disctime=$date
			write "$date,Disconnected,$contime,$conlength,0,$idle,Offline"
			write "$date,Disconnected,$contime,$conlength,0,$idle,Offline" | out-file $logfile -append
		}
		$timesince=[math]::round(([timespan]($date - $disctime)).TotalSeconds,1)
		if ($contime -ne $null) {remove-variable -name contime}
		if ($timesince -gt $ecushutdown -and $idle -gt $idletimeout) {
			if ($compstate -ne "shutdown") {
				$date=get-date
				write "$date,Disconnected,$disctime,0,$timesince,$idle,Hibernate"
				write "$date,Disconnected,$disctime,0,$timesince,$idle,Hibernate" | out-file $logfile -append
				$compstate="shutdown"
#				RUNDLL32.EXE powrprof.dll,SetSuspendState 0,1,0
				if ($error -ne $null) {remove-variable -name error}
				shutdown.exe /h
				$date=get-date
				if ($error -ne $null) {
					write "$date,Hibernate Error: $error" | out-file $logfile -append
					write "$date,Hibernate Error: $error"
				} else {
					write "$date,Hibernate Successfully Initiated"
					write "$date,Hibernate Successfully Initiated" | out-file $logfile -append
				}
				write "$date,Pausing to give hibernate a chance to complete..."
				write "$date,Pausing to give hibernate a chance to complete..." | out-file $logfile -append
				sleep 5
				$date2=get-date
				write "$date2,Hibernate should be complete."
				write "$date2,Hibernate should be complete." | out-file $logfile -append
				
				$timesincehibernate=[math]::round(([timespan]($date2 - $date)).TotalSeconds,1)
				$date=get-date
				write "$date,Time since hibernate: $timesincehibernate"
				write "$date,Time since hibernate: $timesincehibernate" | out-file $logfile -append
				if ($timesincehibernate -gt 10) {
					write "$date,Woken from Hibernate"
					write "$date,Woken from Hibernate" | out-file $logfile -append
					write "$date,Disconnected,$disctime,0,$timesince,$idle,StayAwake"
					write "$date,Disconnected,$disctime,0,$timesince,$idle,StayAwake" | out-file $logfile -append
					$disctime=$date
					$compstate="stayawake"
				} else {
					write "$date,Disconnected,$disctime,0,$timesince,$idle,Hibernate-Fail"
					write "$date,Disconnected,$disctime,0,$timesince,$idle,Hibernate-Fail" | out-file $logfile -append
					closets
					sleep 5
					$date=get-date
					write "$date,Disconnected,$disctime,0,$timesince,$idle,Hybrid-Shutdown"
					write "$date,Disconnected,$disctime,0,$timesince,$idle,Hybrid-Shutdown" | out-file $logfile -append
					shutdown.exe /s /hybrid /t 0
					sleep 30
					$date=get-date
					write "$date,Disconnected,$disctime,0,$timesince,$idle,ForcePowerOff"
					write "$date,Disconnected,$disctime,0,$timesince,$idle,ForcePowerOff" | out-file $logfile -append
					stop-computer -force
					exit
				}
			}
		} elseif ($timesince -gt $ecutimeout -and $idle -gt $idletimeout) {
			if ($compstate -ne "monitoroff") {
				write "$date,Disconnected,$disctime,0,$timesince,$idle,MonitorOff"
				write "$date,Disconnected,$disctime,0,$timesince,$idle,MonitorOff" | out-file $logfile -append
				$compstate="monitoroff"
				$SendMessage::SendMessage($HWND, $WM_SYSCOMMAND, $SC_MONITORPOWER, $MONITOR_OFF)
			}
		} else {
			if ($compstate -eq "monitoroff") {
				write "$date,Disconnected,$disctime,0,$timesince,$idle,StayAwake"
				write "$date,Disconnected,$disctime,0,$timesince,$idle,StayAwake" | out-file $logfile -append
				$WShell = New-Object -Com "Wscript.Shell"
				$WShell.SendKeys('+')
			}
			$compstate="stayawake"
		}
	}
	if ($firstrun -eq $true) {
		write "$date,FirstRun,$ecustate"
		write "$date,FirstRun,$ecustate" | out-file $logfile -append
		$firstrun=$false
	}
	sleep $frequency
}
